<?php

/* Minimum necessaire 
*/
// $Token = 'Votre_cle_personnalisée';
// include('lib/nusoap.php');
// ini_set("soap.wsdl_cache_enabled", "1");
// $client = new nusoap_client('http://adresse-raspberry/pidroid/wspi.php?wsdl');
//
// * Pour ecrire sur un pin :
// $parametres = array('pin'=>1, 'valeur'=>0, 'cle' =>$Token);
// echo $client->call('setPin', $parametres);
//
// * Pour lire sur un pin :
// $parametres = array('pin'=>$pin, 'cle' =>$Token);
// echo $client->call('getPin', $parametres);
/* 
Fin du minimum */

/* Initialisation des variables */
$WS_adresse = 'http://adresse-raspberry/pidroid/'; 	// Adresse du WebService.
$Token = 'DP37TFamTj'; 															// Clé de sécurité du WebService.
$lireEtat = 1; 	// Mettre 1 en parametre pour lire les valeurs en même temps que les retours d'informations du matériel.

/* Déclaration du webService */
include('lib/nusoap.php');
ini_set("soap.wsdl_cache_enabled", "0");
$client = new nusoap_client($WS_adresse.'wspi.php?wsdl');
	
	
/* Fonction cliente permettant de changer l'état d'un port GPIO */
/* Valeur envoyée : $pin = N° WiringPi : $valeur = 0 pour etteindre, 1 pour allumer */
/* La valeur de retour est l'état réel : 0 (éteind), ou 1 (allumé), lu sur le GPIO après action demandée */
function clientEcritWeb($pin, $valeur) {
	global $client, $Token;
	$parametres = array('pin'=>$pin, 'valeur'=>$valeur, 'cle' =>$Token);
	return $client->call('setPin', $parametres);
}

/* Fonction cliente permettant de lire l'état d'un port GPIO */
/* Valeur envoyée : $pin = N° WiringPi */
/* La valeur de retour est l'état réel : 0 (éteind), ou 1 (allumé) */
function clientLitWeb($pin) {
	global $client, $Token;
	$parametres = array('pin'=>$pin, 'cle' =>$Token);
	return $client->call('getPin', $parametres);
}

/* Fonction cliente utilisant un tableau en retour d'information */
/* Valeur envoyée : $litEtat = donne la valeur du GPIO oui (1) ou non (0) */
/* La valeur de retour est un tableau contenant le numéro WiringPi, le nom du Gpio, et l'état si $litEtat = 1 */
function listeMateriel($litEtat=0) {
	global $client, $Token;
	$parametres = array('cle' =>$Token, 'litEtat' =>$litEtat);
	return $client->call('getMaterielTab', $parametres);
}

function noel() {
	for ($i = 1; $i <= 40; $i++) {
		$aleatoire = rand(0, 7);
		$valeur = clientLitWeb($aleatoire);
		if ($valeur == 0) $valeur = 1; else $valeur = 0;
		clientEcritWeb($aleatoire, $valeur);
	}
	
	/* On eteind tout */
	for ($i = 0; $i <= 7; $i++) {
		clientEcritWeb($i, 0);
	}
}

// echo clientEcritWeb(7,0);
// noel();


/* Script necessaire pour la partie supérieure de la page qui n'interroge pas les GPIO Actifs */
/* ****************************************************************************************** */
/* Tableau de correspondant PIN physiques / PIN wiringPI */
$pins = array(11=>0, 12=>1, 13=>2, 15=>3, 16=>4, 18=>5, 22=>6, 7=>7);
/* Liste des pins que l'on souhaite commander */
$commandes = array(
			"Led N° 1"=>11,
			"Led N° 2"=>12,
			"Led N° 3"=>13,
			"Led N° 4"=>15,
			"Led N° 5"=>16,
			"Led N° 6"=>18,
			"Led N° 7"=>22,
			"Led N° 8"=>7
				);
/* Si une action est demandé, on l'exécute */
if ($_POST['envoi'] == "OK") {
	/* On envoi la commande si elle est demandée */
	$retour = clientEcritWeb($_POST['wiringpi'], $_POST['action']);
}
/* *************************** Fin de la partie supérieure ********************************** */
/* ****************************************************************************************** */


$entete = '<head><meta charset="utf-8"><title>PiDroid</title>
	<meta name="description" content="">
	<meta name="author" content="Dominique">
	<link rel="stylesheet" href="style.css">
</head>';

echo '
<!doctype html>'.$entete.'
	<body>';
	

/* Script necessaire pour la partie supérieure de la page qui n'interroge pas les GPIO Actifs */
/* ****************************************************************************************** */
/* Si une action est demandé, on l'exécute */
echo '
		<form method="post" action="">
			<p>Sélectionner l\'action à effectuer :</p>
			<p>
				<label>Numéro du pin : </label>
				<select name="wiringpi">';
					foreach($commandes as $commande=>$pin) 
						echo '<option value="'.$pins[$pin].'"'.($pins[$pin]==$_POST['wiringpi'] ? ' selected="selected"' : '').'>'.$commande.'</option>';
				echo '
				</select>
				<label style="margin-left: 30px;">Action : </label>
				<select name="action">
					<option value="1"'.($_POST['action'] == 1 ? ' selected="selected"' : '').'>Allumé</option>
					<option value="0"'.($_POST['action'] == 0 ? ' selected="selected"' : '').'>Eteindre</option>
				</select>
				<input name = "envoi" type="hidden" value="OK" />
				<input style="margin-left: 30px;" type="submit" value="Envoyer" />
			</p>
		</form>';
/* *************************** Fin de la partie supérieure ********************************** */
/* ****************************************************************************************** */

echo '<p>&nbsp;</p><hr /><p>&nbsp;</p>';


/* Script necessaire pour la partie inférieure de la page qui interroge les GPIO Actifs */
/* ************************************************************************************ */
if ($_GET['envoi'] == "OK") {
	/* On envoi la commande si elle est demandée */
	clientEcritWeb($_GET['wiringpi'], $_GET['action']);
}
$materiels = listeMateriel($lireEtat); 
if (is_array($materiels)) {
	foreach ($materiels as $materiel) {
		echo '<div><p>'. $materiel['nom'] . '</p><p>WiringPi N° : '. $materiel['pin'] . '<br>';
		if ($lireEtat == 1) {
			echo '<a href="?envoi=OK&wiringpi='.$materiel['pin'].'&action=';
			if ($materiel['etat']==1) {
				echo '0" class="allume"><span class="allume">Allumé</span>';
			} else {
				echo '1" class="eteind"><span class="eteind">Eteind</span>';
			} 
			echo '</a>';
		}
		echo '</p></div>';
	}
} else echo "<p>Pas de retour, soit il n'existe aucun Pin configuré dans le WebService, soit le WebService ne répond pas</p>";
/* *************************** Fin de la partie inférieure ****************************** */
/* ************************************************************************************** */

echo '<p style="clear:both">&nbsp;</p><hr /><p>&nbsp;</p>';


/* *************************** Script Guirlande de noel ******************************* */
/* ************************************************************************************ */
if ($_GET['envoi'] == "noel") noel();
echo '<a href="?envoi=noel">Guirlande de Noël</a>';
/* *************************** Fin de Guirlande de noel ******************************* */
/* ************************************************************************************ */

echo'
	</body>
</html>';

?>
